Reinforcement BeamRebars
|
Menu location |
---|
3D/BIM → Reinforcement tools → Beam Reinforcement |
Workbenches |
Reinforcement, BIM |
Default shortcut |
None |
Introduced in version |
0.19 |
See also |
None |
Description
The Reinforcement BeamRebars tool allows the user to create reinforcing bars inside a Beam Arch Structure object.
This tool is part of the Reinforcement Workbench, an external workbench that can be installed with the Addon Manager.
Beam Reinforcement inside a Beam Arch Structure
Usage
1. Select right face of a previously created beam Arch Structure object having length along x-axis. Or select front face of a previously created beam
Arch Structure object having length along y-axis.
2. Then select Beam Reinforcement from the rebar tools.
3. A dialog box will pop-out on screen as shown below.
4. Select the desired type of beam reinforcement.
5. Give inputs for data related to stirrups.
6. Click Next and the dialog box will be updated as shown below.
7. Set data for top rebars.
- To edit Number#Diameter@Offset value, click on the Edit button next to Number#Diameter@Offset label. A dialog box will pop-out as shown below.
- To edit Rebar Type value, click on the Edit button next to Rebar Type label. A dialog box will pop-out as shown below.
- To edit Hook Orientation value, click on the Edit button next to Hook Orientation label. A dialog box will pop-out as shown below.
- To edit Hook Extension value, click on the Edit button next to Hook Extension label. A dialog box will pop-out as shown below.
- To edit LRebar Rounding value, click on the Edit button next to Rounding label. A dialog box will pop-out as shown below.
- To edit Layer Spacing value, click on the Edit button next to Layer Spacing label. A dialog box will pop-out as shown below.
8. Click Next and the dialog box will be updated as shown below.
9. Set data for bottom rebars similar to top rebars data.
10. Click Next and the dialog box will be updated as shown below.
11. Set data for left shear rebars.
- To edit Number#Diameter@Offset value, click on the Edit button next to Number#Diameter@Offset label. A dialog box will pop-out as shown below.
- To edit Rebar Type value, click on the Edit button next to Rebar Type label. A dialog box will pop-out as shown below.
- To edit Hook Orientation value, click on the Edit button next to Hook Orientation label. A dialog box will pop-out as shown below.
- To edit Hook Extension value, click on the Edit button next to Hook Extension label. A dialog box will pop-out as shown below.
- To edit LRebar Rounding value, click on the Edit button next to Rounding label. A dialog box will pop-out as shown below.
12. Click Next and the dialog box will be updated as shown below.
13. Set data for right shear rebars similar to left shear rebars data.
14. Click OK or Apply to generate beam reinforcement.
15. Click Cancel to exit the dialog box.
Properties
Stirrups:
- DataLeft Cover: The distance between the left end of the stirrup to the left face of the structure.
- DataRight Cover: The distance between the right end of the stirrup to right face of the structure.
- DataTop Cover: The distance between stirrup from the top face of the structure.
- DataBottom Cover: The distance between stirrup from the bottom face of the structure.
- DataOffset: The distance between stirrup from the selected/back face of the structure.
- DataDiameter: Diameter of the stirrup.
- DataBent Angle: Bent angle defines the angle at the ends of a stirrup.
- DataExtension Factor: Extension Factor defines length of end of stirrup, expressed in times the diameter.
- DataNumber: The number of stirrup.
- DataSpacing: The distance between the axes of each stirrup.
Top/Bottom Reinforcement Rebars: Rebars present at top/bottom side of beam
- DataNumberDiameterOffset: A tuple of Number#Diameter@Offset string. Each element of tuple represents reinforcement for each new layer.
- DataRebar Type: List of tuple of type of reinforcement bars.
- DataHook Orientation: List of tuple of orientation of LShaped hooks.
- DataHook Extension: List of tuple of length of hook of LShaped rebars.
- DataRounding: List of tuple of a rounding value to be applied to the corners of the LShape rebars, expressed in times the diameter.
- DataLayer Spacing: List of spacing between two consecutive reinforcement layers.
Left/Right Reinforcement Rebars: Rebars present at left/right side of beam
- DataNumberDiameterOffset: String of Number#Diameter@Offset set for reinforcement bars.
- DataRebar Type: List of type of reinforcement bars.
- DataHook Orientation: List of orientation of LShaped hooks.
- DataHook Extension: List of length of hook of LShaped rebars.
- DataRounding: List of a rounding value to be applied to the corners of the LShape rebars, expressed in times the diameter.
- DataRebar Spacing: Clear spacing between consecutive reinforcement bars.
Scripting
See also: Arch API, Reinforcement API and FreeCAD Scripting Basics.
The Reinforcement BeamRebars tool can be used in macros and from the Python console by using the following function:
Create Two Legged Stirrups
RebarGroup = makeReinforcement(
l_cover_of_stirrup,
r_cover_of_stirrup,
t_cover_of_stirrup,
b_cover_of_stirrup,
offset_of_stirrup,
bent_angle,
extension_factor,
dia_of_stirrup,
number_spacing_check,
number_spacing_value,
top_reinforcement_number_diameter_offset,
top_reinforcement_rebar_type,
top_reinforcement_layer_spacing,
bottom_reinforcement_number_diameter_offset,
bottom_reinforcement_rebar_type,
bottom_reinforcement_layer_spacing,
left_rebars_number_diameter_offset,
left_rebars_type,
left_rebars_spacing,
right_rebars_number_diameter_offset,
right_rebars_type,
right_rebars_spacing,
top_reinforcement_l_rebar_rounding=2,
top_reinforcement_hook_extension=40,
top_reinforcement_hook_orientation="Front Inside",
bottom_reinforcement_l_rebar_rounding=2,
bottom_reinforcement_hook_extension=40,
bottom_reinforcement_hook_orientation="Front Inside",
left_l_rebar_rounding=2,
left_rebars_hook_extension=40,
left_rebars_hook_orientation="Front Inside",
right_l_rebar_rounding=2,
right_rebars_hook_extension=40,
right_rebars_hook_orientation="Front Inside",
structure=None,
facename=None,
)
- Creates a
RebarGroup
object from the givenstructure
, which is an Arch Structure, andfacename
, which is a face of that structure.- If no
structure
norfacename
are given, it will take the user selected face as input.
- If no
l_cover_of_stirrup
,r_cover_of_stirrup
,t_cover_of_stirrup
,b_cover_of_stirrup
andoffset_of_stirrup
are inner offset distances for the stirrup elements with respect to the faces of the structure. They are respectively the left, right, top, bottom and front/rear offsets.bent_angle
define the angle of the tip of the reinforcement loop of stirrup.extension_factor
define the length of the tip of the reinforcement loop of stirrup, expressed in times the diameter.dia_of_stirrup
is the diameter of the stirrup.number_spacing_check
if it isTrue
it will create as many stirrup as given bynumber_spacing_value
; if it isFalse
it will create stirrup separated by the numerical value ofnumber_spacing_value
.number_spacing_value
specifies the number of stirrups, or the value of the separation between them, depending onnumber_spacing_check
.top_reinforcement_number_diameter_offset
andbottom_reinforcement_number_diameter_offset
are tuple of number_diameter_offset string. Each element of tuple represents reinforcement for each new layer.
Syntax: ( "number1#diameter1@offset1+number2#diameter2@offset2+...", "number3#diameter3@offset3+number4#diameter4@offset4+...", ..., )
top_reinforcement_rebar_type
andbottom_reinforcement_rebar_type
specifies type of top/bottom reinforcement bars.
Possible values: 1. 'StraightRebar' or 'LShapeRebar' 2. ('<rebar_type>', '<rebar_type>', ...) and number of elements of tuple must be equal to number of reinforcement layers. 3. [ ('<rebar_type>', '<rebar_type>', ...), ('<rebar_type>', '<rebar_type>', ...), ..., ] each element of list is a tuple, which specifies rebar type of each reinforcement layer. And each element of tuple represents rabar_type for each set of rebars. 4. [ <rebar_type>, ('<rebar_type>', '<rebar_type>', ...), ..., ]
top_reinforcement_layer_spacing
andbottom_reinforcement_layer_spacing
is the spacing between two consecutive reinforcement layers.
Possible values: 1. <layer_spacing> 2. (<spacing in layer1 and layer2>, <spacing in layer2 and layer3>, ...) and number of elements of tuple must be equal to one less than number of layers.
left_rebars_number_diameter_offset
andright_rebars_number_diameter_offset
are string of number_diameter_offset.
Syntax: "number1#diameter1@offset1+number2#diameter2@offset2+..."
left_rebars_type
andright_rebars_type
specifies type of left/right reinforcement bars.
Possible values: 1. 'StraightRebar' or 'LShapeRebar' 2. ('<rebar_type>', '<rebar_type>', ...) and each element of tuple represents rabar_type for each set of rebars.
left_rebars_spacing
andright_rebars_spacing
is clear spacing between consecutive reinforcement bars.top_reinforcement_l_rebar_rounding
andbottom_reinforcement_l_rebar_rounding
is the parameter that determines the bending radius of the LShaped top/bottom rebars, expressed as times the diameter. Possible syntax are similar to as discussed above fortop_reinforcement_rebar_type
/bottom_reinforcement_rebar_type
.top_reinforcement_hook_extension
andbottom_reinforcement_hook_extension
is the length of hook of LShaped rebars. Possible syntax are similar to as discussed above fortop_reinforcement_rebar_type
/bottom_reinforcement_rebar_type
.top_reinforcement_hook_orientation
andbottom_reinforcement_hook_orientation
specifies the orientation of LShaped hook; it can be"Front Inside"
,"Front Outside"
,"Rear Inside"
or"Rear Outside"
. Possible syntax are similar to as discussed above fortop_reinforcement_rebar_type
/bottom_reinforcement_rebar_type
.left_l_rebar_rounding
andright_l_rebar_rounding
is the parameter that determines the bending radius of the LShaped left/right rebars, expressed as times the diameter. Possible syntax are similar to as discussed above forleft_rebars_type
/right_rebars_type
.left_rebars_hook_extension
andright_rebars_hook_extension
is the length of hook of LShaped rebars. Possible syntax are similar to as discussed above forleft_rebars_type
/right_rebars_type
.left_rebars_hook_orientation
andright_rebars_hook_orientation
specifies the orientation of LShaped hook; it can be"Front Inside"
,"Front Outside"
,"Rear Inside"
or"Rear Outside"
. Possible syntax are similar to as discussed above forleft_rebars_type
/right_rebars_type
.
Example
import FreeCAD, Arch
from BeamReinforcement import TwoLeggedBeam
Structure = Arch.makeStructure(length=3000.0,width=200.0,height=400.0)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()
RebarGroup = TwoLeggedBeam.makeReinforcement(
l_cover_of_stirrup=20,
r_cover_of_stirrup=20,
t_cover_of_stirrup=20,
b_cover_of_stirrup=20,
offset_of_stirrup=100,
bent_angle=135,
extension_factor=4,
dia_of_stirrup=8,
number_spacing_check=False,
number_spacing_value=200,
top_reinforcement_number_diameter_offset=("1#20@-60+2#16@-60+1#20@-60", "3#16@-100"),
top_reinforcement_rebar_type="LShapeRebar",
top_reinforcement_layer_spacing=30,
bottom_reinforcement_number_diameter_offset=("1#20@-60+2#16@-60+1#20@-60", "3#16@-100"),
bottom_reinforcement_rebar_type="LShapeRebar",
bottom_reinforcement_layer_spacing=30,
left_rebars_number_diameter_offset="1#16@-100+1#16@-100+1#16@-100",
left_rebars_type="LShapeRebar",
left_rebars_spacing=30,
right_rebars_number_diameter_offset="1#16@-100+1#16@-100+1#16@-100",
right_rebars_type="LShapeRebar",
right_rebars_spacing=30,
top_reinforcement_l_rebar_rounding=2,
top_reinforcement_hook_extension=100,
top_reinforcement_hook_orientation="Rear Outside",
bottom_reinforcement_l_rebar_rounding=2,
bottom_reinforcement_hook_extension=100,
bottom_reinforcement_hook_orientation="Rear Outside",
left_l_rebar_rounding=2,
left_rebars_hook_extension=80,
left_rebars_hook_orientation=("Rear Inside", "Front Inside", "Rear Inside"),
right_l_rebar_rounding=2,
right_rebars_hook_extension=80,
right_rebars_hook_orientation=("Front Inside", "Rear Inside", "Front Inside"),
structure=Structure,
facename="Face6",
)
- 2D drafting: Sketch, Line, Polyline, Circle, Arc, Arc by 3 points, Fillet, Ellipse, Polygon, Rectangle, B-spline, Bézier curve, Cubic Bézier curve, Point
- 3D/BIM: Project, Site, Building, Level, Space, Wall, Curtain Wall, Column, Beam, Slab, Door, Window, Pipe, Pipe Connector, Stairs, Roof, Panel, Frame, Fence, Truss, Equipment
- Reinforcement tools: Custom Rebar, Straight Rebar, U-Shape Rebar, L-Shape Rebar, Stirrup, Bent-Shape Rebar, Helical Rebar, Column Reinforcement, Beam Reinforcement, Slab Reinforcement, Footing Reinforcement
- Generic 3D tools: Profile, Box, Shape builder..., Facebinder, Objects library, Component, External reference
- Annotation: Text, Shape from text, Aligned dimension, Horizontal dimension, Vertical dimension, Leader, Label, Axis, Axes System, Grid, Section Plane, Hatch, Page, View, Shape-based view
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid, Working Plane Top, Working Plane Front, Working Plane Side
- Modify: Move, Copy, Rotate, Clone, Create simple copy, Make compound, Offset, 2D Offset..., Trimex, Join, Split, Scale, Stretch, Draft to sketch, Upgrade, Downgrade, Add component, Remove component, Array, Path array, Polar array, Point array, Cut with plane, Mirror, Extrude..., Difference, Union, Intersection
- Manage: BIM Setup..., Views manager, Manage project..., Manage doors and windows..., Manage IFC elements..., Manage IFC quantities..., Manage IFC properties..., Manage classification..., Manage layers..., Material, Schedule, Preflight checks..., Annotation styles...
- Utils: Toggle bottom panels, Move to Trash, Working Plane View, Select group, Set slope, Create working plane proxy, Add to construction group, Split Mesh, Mesh to Shape, Select non-manifold meshes, Remove Shape from Arch, Close Holes, Merge Walls, Check, Toggle IFC Brep flag, Toggle subcomponents, Survey, IFC Diff, IFC explorer, Create IFC spreadsheet..., Image plane, Unclone, Rewire, Glue, Reextrude
- Panel tools: Panel, Panel Cut, Panel Sheet, Nest
- Structure tools: Structure, Structural System, Multiple Structures
- IFC tools: IFC Diff..., IFC Expand, Make IFC project, IfcOpenShell update
- Nudge: Nudge Switch, Nudge Up, Nudge Down, Nudge Left, Nudge Right, Nudge Rotate Left, Nudge Rotate Right, Nudge Extend, Nudge Shrink
- Additional: Preferences, Fine tuning, Import Export Preferences, IFC, DAE, OBJ, JSON, 3DS, SHP

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub